diff --git a/disas/alpha.c b/disas/alpha.c
index a950b9c..44d00a3 100644
--- a/disas/alpha.c
+++ b/disas/alpha.c
@@ -19,7 +19,7 @@ You should have received a copy of the GNU General Public License
 along with this file; see the file COPYING.  If not, see
 <http://www.gnu.org/licenses/>. */
 
-#include <stdio.h>
+#include "qemu/osdep.h"
 #include "disas/bfd.h"
 
 /* MAX is redefined below, so remove any previous definition. */
diff --git a/hw/alpha/dp264.c b/hw/alpha/dp264.c
index 38b85ba..992d1b2 100644
--- a/hw/alpha/dp264.c
+++ b/hw/alpha/dp264.c
@@ -6,6 +6,7 @@
  * that we need to emulate as well.
  */
 
+#include "qemu/osdep.h"
 #include "hw/hw.h"
 #include "elf.h"
 #include "hw/loader.h"
diff --git a/hw/alpha/pci.c b/hw/alpha/pci.c
index 5226e43..fb902bb 100644
--- a/hw/alpha/pci.c
+++ b/hw/alpha/pci.c
@@ -6,7 +6,7 @@
  * ??? Sparse memory access not implemented.
  */
 
-#include "config.h"
+#include "qemu/osdep.h"
 #include "alpha_sys.h"
 #include "qemu/log.h"
 #include "sysemu/sysemu.h"
diff --git a/hw/alpha/typhoon.c b/hw/alpha/typhoon.c
index 35dc8a5..b86ff5e 100644
--- a/hw/alpha/typhoon.c
+++ b/hw/alpha/typhoon.c
@@ -6,6 +6,7 @@
  * This work is licensed under the GNU GPL license version 2 or later.
  */
 
+#include "qemu/osdep.h"
 #include "cpu.h"
 #include "hw/hw.h"
 #include "hw/devices.h"
diff --git a/target-alpha/cpu.c b/target-alpha/cpu.c
index e5bdfa8..2eab060 100644
--- a/target-alpha/cpu.c
+++ b/target-alpha/cpu.c
@@ -19,6 +19,7 @@
  * <http://www.gnu.org/licenses/lgpl-2.1.html>
  */
 
+#include "qemu/osdep.h"
 #include "cpu.h"
 #include "qemu-common.h"
 #include "migration/vmstate.h"
diff --git a/target-alpha/fpu_helper.c b/target-alpha/fpu_helper.c
index 0c65e1f..5ab7d5e 100644
--- a/target-alpha/fpu_helper.c
+++ b/target-alpha/fpu_helper.c
@@ -17,6 +17,7 @@
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
 
+#include "qemu/osdep.h"
 #include "cpu.h"
 #include "exec/helper-proto.h"
 #include "fpu/softfloat.h"
diff --git a/target-alpha/gdbstub.c b/target-alpha/gdbstub.c
index 99a4051..199f028 100644
--- a/target-alpha/gdbstub.c
+++ b/target-alpha/gdbstub.c
@@ -17,7 +17,7 @@
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
-#include "config.h"
+#include "qemu/osdep.h"
 #include "qemu-common.h"
 #include "exec/gdbstub.h"
 
diff --git a/target-alpha/helper.c b/target-alpha/helper.c
index 5a85335..6dec263 100644
--- a/target-alpha/helper.c
+++ b/target-alpha/helper.c
@@ -17,9 +17,7 @@
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
 
-#include <stdint.h>
-#include <stdlib.h>
-#include <stdio.h>
+#include "qemu/osdep.h"
 
 #include "cpu.h"
 #include "fpu/softfloat.h"
diff --git a/target-alpha/int_helper.c b/target-alpha/int_helper.c
index d7f4774..777e48d 100644
--- a/target-alpha/int_helper.c
+++ b/target-alpha/int_helper.c
@@ -17,6 +17,7 @@
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
 
+#include "qemu/osdep.h"
 #include "cpu.h"
 #include "exec/helper-proto.h"
 #include "qemu/host-utils.h"
diff --git a/target-alpha/machine.c b/target-alpha/machine.c
index d9bf977..9ab0928 100644
--- a/target-alpha/machine.c
+++ b/target-alpha/machine.c
@@ -1,3 +1,4 @@
+#include "qemu/osdep.h"
 #include "hw/hw.h"
 #include "hw/boards.h"
 
diff --git a/target-alpha/mem_helper.c b/target-alpha/mem_helper.c
index c9258f5..7fee9a6 100644
--- a/target-alpha/mem_helper.c
+++ b/target-alpha/mem_helper.c
@@ -17,6 +17,7 @@
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
 
+#include "qemu/osdep.h"
 #include "cpu.h"
 #include "exec/helper-proto.h"
 #include "exec/cpu_ldst.h"
diff --git a/target-alpha/sys_helper.c b/target-alpha/sys_helper.c
index 75c96c1..e2dec15 100644
--- a/target-alpha/sys_helper.c
+++ b/target-alpha/sys_helper.c
@@ -17,6 +17,7 @@
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
 
+#include "qemu/osdep.h"
 #include "cpu.h"
 #include "exec/helper-proto.h"
 #include "sysemu/sysemu.h"
diff --git a/target-alpha/translate.c b/target-alpha/translate.c
index 9909c70..7d419d9 100644
--- a/target-alpha/translate.c
+++ b/target-alpha/translate.c
@@ -17,6 +17,7 @@
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
 
+#include "qemu/osdep.h"
 #include "cpu.h"
 #include "disas/disas.h"
 #include "qemu/host-utils.h"
diff --git a/target-alpha/vax_helper.c b/target-alpha/vax_helper.c
index 2e2f499..e74ac3e 100644
--- a/target-alpha/vax_helper.c
+++ b/target-alpha/vax_helper.c
@@ -17,6 +17,7 @@
  * License along with this library; if not, see <http://www.gnu.org/licenses/>.
  */
 
+#include "qemu/osdep.h"
 #include "cpu.h"
 #include "exec/helper-proto.h"
 #include "fpu/softfloat.h"